// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: solarmodule/solarmodule.proto

package openfmb.solarmodule;

/**
 * <pre>
 * Specialized 61850 FSCC class.  LN: Schedule controller   Name: FSCC
 * </pre>
 *
 * Protobuf type {@code solarmodule.SolarControlFSCC}
 */
public final class SolarControlFSCC extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:solarmodule.SolarControlFSCC)
    SolarControlFSCCOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SolarControlFSCC.newBuilder() to construct.
  private SolarControlFSCC(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SolarControlFSCC() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SolarControlFSCC();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarControlFSCC_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarControlFSCC_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.solarmodule.SolarControlFSCC.class, openfmb.solarmodule.SolarControlFSCC.Builder.class);
  }

  public static final int CONTROLFSCC_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ControlFSCC controlFSCC_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the controlFSCC field is set.
   */
  @java.lang.Override
  public boolean hasControlFSCC() {
    return controlFSCC_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
   * @return The controlFSCC.
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlFSCC getControlFSCC() {
    return controlFSCC_ == null ? openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ControlFSCCOrBuilder getControlFSCCOrBuilder() {
    return controlFSCC_ == null ? openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
  }

  public static final int SOLARCONTROLSCHEDULEFSCH_FIELD_NUMBER = 2;
  private openfmb.solarmodule.SolarControlScheduleFSCH solarControlScheduleFSCH_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
   * @return Whether the solarControlScheduleFSCH field is set.
   */
  @java.lang.Override
  public boolean hasSolarControlScheduleFSCH() {
    return solarControlScheduleFSCH_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
   * @return The solarControlScheduleFSCH.
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarControlScheduleFSCH getSolarControlScheduleFSCH() {
    return solarControlScheduleFSCH_ == null ? openfmb.solarmodule.SolarControlScheduleFSCH.getDefaultInstance() : solarControlScheduleFSCH_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarControlScheduleFSCHOrBuilder getSolarControlScheduleFSCHOrBuilder() {
    return solarControlScheduleFSCH_ == null ? openfmb.solarmodule.SolarControlScheduleFSCH.getDefaultInstance() : solarControlScheduleFSCH_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (controlFSCC_ != null) {
      output.writeMessage(1, getControlFSCC());
    }
    if (solarControlScheduleFSCH_ != null) {
      output.writeMessage(2, getSolarControlScheduleFSCH());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (controlFSCC_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getControlFSCC());
    }
    if (solarControlScheduleFSCH_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getSolarControlScheduleFSCH());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.solarmodule.SolarControlFSCC)) {
      return super.equals(obj);
    }
    openfmb.solarmodule.SolarControlFSCC other = (openfmb.solarmodule.SolarControlFSCC) obj;

    if (hasControlFSCC() != other.hasControlFSCC()) return false;
    if (hasControlFSCC()) {
      if (!getControlFSCC()
          .equals(other.getControlFSCC())) return false;
    }
    if (hasSolarControlScheduleFSCH() != other.hasSolarControlScheduleFSCH()) return false;
    if (hasSolarControlScheduleFSCH()) {
      if (!getSolarControlScheduleFSCH()
          .equals(other.getSolarControlScheduleFSCH())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasControlFSCC()) {
      hash = (37 * hash) + CONTROLFSCC_FIELD_NUMBER;
      hash = (53 * hash) + getControlFSCC().hashCode();
    }
    if (hasSolarControlScheduleFSCH()) {
      hash = (37 * hash) + SOLARCONTROLSCHEDULEFSCH_FIELD_NUMBER;
      hash = (53 * hash) + getSolarControlScheduleFSCH().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarControlFSCC parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.solarmodule.SolarControlFSCC prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Specialized 61850 FSCC class.  LN: Schedule controller   Name: FSCC
   * </pre>
   *
   * Protobuf type {@code solarmodule.SolarControlFSCC}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:solarmodule.SolarControlFSCC)
      openfmb.solarmodule.SolarControlFSCCOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarControlFSCC_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarControlFSCC_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.solarmodule.SolarControlFSCC.class, openfmb.solarmodule.SolarControlFSCC.Builder.class);
    }

    // Construct using openfmb.solarmodule.SolarControlFSCC.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      controlFSCC_ = null;
      if (controlFSCCBuilder_ != null) {
        controlFSCCBuilder_.dispose();
        controlFSCCBuilder_ = null;
      }
      solarControlScheduleFSCH_ = null;
      if (solarControlScheduleFSCHBuilder_ != null) {
        solarControlScheduleFSCHBuilder_.dispose();
        solarControlScheduleFSCHBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarControlFSCC_descriptor;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarControlFSCC getDefaultInstanceForType() {
      return openfmb.solarmodule.SolarControlFSCC.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarControlFSCC build() {
      openfmb.solarmodule.SolarControlFSCC result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarControlFSCC buildPartial() {
      openfmb.solarmodule.SolarControlFSCC result = new openfmb.solarmodule.SolarControlFSCC(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.solarmodule.SolarControlFSCC result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.controlFSCC_ = controlFSCCBuilder_ == null
            ? controlFSCC_
            : controlFSCCBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.solarControlScheduleFSCH_ = solarControlScheduleFSCHBuilder_ == null
            ? solarControlScheduleFSCH_
            : solarControlScheduleFSCHBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.solarmodule.SolarControlFSCC) {
        return mergeFrom((openfmb.solarmodule.SolarControlFSCC)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.solarmodule.SolarControlFSCC other) {
      if (other == openfmb.solarmodule.SolarControlFSCC.getDefaultInstance()) return this;
      if (other.hasControlFSCC()) {
        mergeControlFSCC(other.getControlFSCC());
      }
      if (other.hasSolarControlScheduleFSCH()) {
        mergeSolarControlScheduleFSCH(other.getSolarControlScheduleFSCH());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getControlFSCCFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getSolarControlScheduleFSCHFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ControlFSCC controlFSCC_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlFSCC, openfmb.commonmodule.ControlFSCC.Builder, openfmb.commonmodule.ControlFSCCOrBuilder> controlFSCCBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the controlFSCC field is set.
     */
    public boolean hasControlFSCC() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     * @return The controlFSCC.
     */
    public openfmb.commonmodule.ControlFSCC getControlFSCC() {
      if (controlFSCCBuilder_ == null) {
        return controlFSCC_ == null ? openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
      } else {
        return controlFSCCBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlFSCC(openfmb.commonmodule.ControlFSCC value) {
      if (controlFSCCBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        controlFSCC_ = value;
      } else {
        controlFSCCBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setControlFSCC(
        openfmb.commonmodule.ControlFSCC.Builder builderForValue) {
      if (controlFSCCBuilder_ == null) {
        controlFSCC_ = builderForValue.build();
      } else {
        controlFSCCBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeControlFSCC(openfmb.commonmodule.ControlFSCC value) {
      if (controlFSCCBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          controlFSCC_ != null &&
          controlFSCC_ != openfmb.commonmodule.ControlFSCC.getDefaultInstance()) {
          getControlFSCCBuilder().mergeFrom(value);
        } else {
          controlFSCC_ = value;
        }
      } else {
        controlFSCCBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearControlFSCC() {
      bitField0_ = (bitField0_ & ~0x00000001);
      controlFSCC_ = null;
      if (controlFSCCBuilder_ != null) {
        controlFSCCBuilder_.dispose();
        controlFSCCBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlFSCC.Builder getControlFSCCBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getControlFSCCFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.ControlFSCCOrBuilder getControlFSCCOrBuilder() {
      if (controlFSCCBuilder_ != null) {
        return controlFSCCBuilder_.getMessageOrBuilder();
      } else {
        return controlFSCC_ == null ?
            openfmb.commonmodule.ControlFSCC.getDefaultInstance() : controlFSCC_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.ControlFSCC controlFSCC = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ControlFSCC, openfmb.commonmodule.ControlFSCC.Builder, openfmb.commonmodule.ControlFSCCOrBuilder> 
        getControlFSCCFieldBuilder() {
      if (controlFSCCBuilder_ == null) {
        controlFSCCBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ControlFSCC, openfmb.commonmodule.ControlFSCC.Builder, openfmb.commonmodule.ControlFSCCOrBuilder>(
                getControlFSCC(),
                getParentForChildren(),
                isClean());
        controlFSCC_ = null;
      }
      return controlFSCCBuilder_;
    }

    private openfmb.solarmodule.SolarControlScheduleFSCH solarControlScheduleFSCH_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarControlScheduleFSCH, openfmb.solarmodule.SolarControlScheduleFSCH.Builder, openfmb.solarmodule.SolarControlScheduleFSCHOrBuilder> solarControlScheduleFSCHBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     * @return Whether the solarControlScheduleFSCH field is set.
     */
    public boolean hasSolarControlScheduleFSCH() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     * @return The solarControlScheduleFSCH.
     */
    public openfmb.solarmodule.SolarControlScheduleFSCH getSolarControlScheduleFSCH() {
      if (solarControlScheduleFSCHBuilder_ == null) {
        return solarControlScheduleFSCH_ == null ? openfmb.solarmodule.SolarControlScheduleFSCH.getDefaultInstance() : solarControlScheduleFSCH_;
      } else {
        return solarControlScheduleFSCHBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    public Builder setSolarControlScheduleFSCH(openfmb.solarmodule.SolarControlScheduleFSCH value) {
      if (solarControlScheduleFSCHBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        solarControlScheduleFSCH_ = value;
      } else {
        solarControlScheduleFSCHBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    public Builder setSolarControlScheduleFSCH(
        openfmb.solarmodule.SolarControlScheduleFSCH.Builder builderForValue) {
      if (solarControlScheduleFSCHBuilder_ == null) {
        solarControlScheduleFSCH_ = builderForValue.build();
      } else {
        solarControlScheduleFSCHBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    public Builder mergeSolarControlScheduleFSCH(openfmb.solarmodule.SolarControlScheduleFSCH value) {
      if (solarControlScheduleFSCHBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          solarControlScheduleFSCH_ != null &&
          solarControlScheduleFSCH_ != openfmb.solarmodule.SolarControlScheduleFSCH.getDefaultInstance()) {
          getSolarControlScheduleFSCHBuilder().mergeFrom(value);
        } else {
          solarControlScheduleFSCH_ = value;
        }
      } else {
        solarControlScheduleFSCHBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    public Builder clearSolarControlScheduleFSCH() {
      bitField0_ = (bitField0_ & ~0x00000002);
      solarControlScheduleFSCH_ = null;
      if (solarControlScheduleFSCHBuilder_ != null) {
        solarControlScheduleFSCHBuilder_.dispose();
        solarControlScheduleFSCHBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    public openfmb.solarmodule.SolarControlScheduleFSCH.Builder getSolarControlScheduleFSCHBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getSolarControlScheduleFSCHFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    public openfmb.solarmodule.SolarControlScheduleFSCHOrBuilder getSolarControlScheduleFSCHOrBuilder() {
      if (solarControlScheduleFSCHBuilder_ != null) {
        return solarControlScheduleFSCHBuilder_.getMessageOrBuilder();
      } else {
        return solarControlScheduleFSCH_ == null ?
            openfmb.solarmodule.SolarControlScheduleFSCH.getDefaultInstance() : solarControlScheduleFSCH_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarControlScheduleFSCH SolarControlScheduleFSCH = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarControlScheduleFSCH, openfmb.solarmodule.SolarControlScheduleFSCH.Builder, openfmb.solarmodule.SolarControlScheduleFSCHOrBuilder> 
        getSolarControlScheduleFSCHFieldBuilder() {
      if (solarControlScheduleFSCHBuilder_ == null) {
        solarControlScheduleFSCHBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.solarmodule.SolarControlScheduleFSCH, openfmb.solarmodule.SolarControlScheduleFSCH.Builder, openfmb.solarmodule.SolarControlScheduleFSCHOrBuilder>(
                getSolarControlScheduleFSCH(),
                getParentForChildren(),
                isClean());
        solarControlScheduleFSCH_ = null;
      }
      return solarControlScheduleFSCHBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:solarmodule.SolarControlFSCC)
  }

  // @@protoc_insertion_point(class_scope:solarmodule.SolarControlFSCC)
  private static final openfmb.solarmodule.SolarControlFSCC DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.solarmodule.SolarControlFSCC();
  }

  public static openfmb.solarmodule.SolarControlFSCC getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SolarControlFSCC>
      PARSER = new com.google.protobuf.AbstractParser<SolarControlFSCC>() {
    @java.lang.Override
    public SolarControlFSCC parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SolarControlFSCC> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SolarControlFSCC> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.solarmodule.SolarControlFSCC getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

